let express = require('express');
let webpack = require('webpack');
let portfinder = require('portfinder');

async function webpackBuild(wefe) {
  let app = express();

  let webpackConfig = require('./webpack.dev.conf')(wefe);
  let compiler = webpack(webpackConfig);

  // handle fallback for HTML5 history API
  app.use(require('connect-history-api-fallback')());

  // serve pure static assets
  app.use(wefe.appDist, express.static('./static'));

  return new Promise((resolve, reject) => {
    let port = 9394;
    portfinder.basePort = 9394;
    portfinder.getPortPromise()
      .then(newPort => {
        if (port !== newPort) {
          console.log(`${port}端口被占用，开启新端口${newPort}`);
        }
        app.listen(newPort, 'localhost');
        // for 小程序的文件保存机制
        require('webpack-dev-middleware-hard-disk')(compiler, {
          publicPath: webpackConfig.output.publicPath,
          quiet: true,
        });
        resolve(wefe);
      }).catch(error => {
        reject(error);
      });
  });
};

module.exports = webpackBuild;